// Created by ihdl
module dig_rxtx100_dig_loopback(MR_DIG_LOOP_BACK_ENAB, MLT3ENC_DATA, MLT3_DATAIN
		, RXCLK125_inv, RESET, LPBK_MLT3DATA, RXCLK125_p838, RXCLK125_p32
		);

	input MR_DIG_LOOP_BACK_ENAB;
	input [1:0] MLT3ENC_DATA;
	input [1:0] MLT3_DATAIN;
	input RXCLK125_inv;
	input RESET;
	output [1:0] LPBK_MLT3DATA;
	input RXCLK125_p838;
	input RXCLK125_p32;

	wire RXCLK125_p838;
	wire RXCLK125_p32;
	wire n_40532;
	wire n_2342;
	wire [1:0] loopback_data;
	wire [1:0] equalizer_data;
	wire [1:0] equalizer_data_clkn;
	wire [1:0] loopback_data_clkn;
	wire n_10729;
	wire RESET;
	wire RXCLK125_inv;
	wire MR_DIG_LOOP_BACK_ENAB;

	supply1 AMBIT_VDD;


	INVX8 i_169906(.A(RXCLK125_p838), .Y(n_40532));
	CLKBUFX1 i_1969(.A(MLT3_DATAIN[1]), .Y(n_2342));
	MX2X1 i_3(.A(equalizer_data[0]), .B(loopback_data[0]), .S0(MR_DIG_LOOP_BACK_ENAB
		), .Y(LPBK_MLT3DATA[0]));
	MX2X1 i_2(.A(equalizer_data[1]), .B(loopback_data[1]), .S0(MR_DIG_LOOP_BACK_ENAB
		), .Y(LPBK_MLT3DATA[1]));
	DFFSRX1 loopback_data_clkn_reg_0(.CK(RXCLK125_inv), .D(MLT3ENC_DATA[0]),
		 .Q(loopback_data_clkn[0]), .RN(n_10729), .SN(AMBIT_VDD));
	DFFSRX1 loopback_data_clkn_reg_1(.CK(RXCLK125_inv), .D(MLT3ENC_DATA[1]),
		 .Q(loopback_data_clkn[1]), .RN(n_10729), .SN(AMBIT_VDD));
	DFFSRX1 loopback_data_reg_0(.CK(RXCLK125_p32), .D(loopback_data_clkn[0])
		, .Q(loopback_data[0]), .RN(n_10729), .SN(AMBIT_VDD));
	DFFSRX1 loopback_data_reg_1(.CK(n_40532), .D(loopback_data_clkn[1]), .Q(loopback_data
		[1]), .RN(n_10729), .SN(AMBIT_VDD));
	DFFSRX1 equalizer_data_clkn_reg_0(.CK(RXCLK125_inv), .D(MLT3_DATAIN[0]),
		 .Q(equalizer_data_clkn[0]), .RN(n_10729), .SN(AMBIT_VDD));
	DFFSRX1 equalizer_data_clkn_reg_1(.CK(RXCLK125_inv), .D(n_2342), .Q(equalizer_data_clkn
		[1]), .RN(n_10729), .SN(AMBIT_VDD));
	DFFSRX1 equalizer_data_reg_0(.CK(n_40532), .D(equalizer_data_clkn[0]), .Q
		(equalizer_data[0]), .RN(n_10729), .SN(AMBIT_VDD));
	DFFSRX1 equalizer_data_reg_1(.CK(n_40532), .D(equalizer_data_clkn[1]), .Q
		(equalizer_data[1]), .RN(n_10729), .SN(AMBIT_VDD));
	INVX2 i_701(.A(RESET), .Y(n_10729));
endmodule
